--[[
    Author: Gaios
    USGN: 18271
    Version: 1.1
]]

DAY_NIGHT_CYCLE = {}
local dnc = DAY_NIGHT_CYCLE

local dayDuration = 600 -- seconds
local nightRange = {1, 100} -- 1-360
local dayRange = {101, 360} -- 1-360

local dayStart = 180
local dayEnd = 316
local multiplier = dayDuration / (dayRange[2] - dayRange[1])
local dayNightMap = {}
local isNightMap = {}

dnc.currentTime = 101 * multiplier

local function generateDayNightMap()
    local dayFactor = (dayEnd - dayStart) / (dayRange[2] - dayRange[1])
    for i = 1, 360 do
        if i >= nightRange[1] and i <= nightRange[2] then
            dayNightMap[i] = dayEnd
            isNightMap[i] = true
        elseif i >= dayRange[1] and i <= dayRange[2] then
            dayNightMap[i] = dayStart + math.ceil((i - dayRange[1]) * dayFactor)
            isNightMap[i] = false
        end
    end
end
generateDayNightMap()

function dnc.setTime(time)
    if time > 360 then
        time = time % 360
    end
    if time == 0 then
        time = 360
    end
    dnc.currentTime = time
    return dnc.getMappedTime(time)
end

function dnc.isNight()
    local time = math.ceil(dnc.currentTime)
    return isNightMap[time]
end

function dnc.isDay()
    return not dnc.isNight()
end

function dnc.getMappedTime(time)
    return dayNightMap[math.ceil(time)]
end

local lastTime = -1
function dnc.onTick()
    local time = dnc.setTime(dnc.currentTime + (1 / multiplier))
    if lastTime ~= time then
        lastTime = time
        parse('sv_daylighttime '..time)
    end
end
addhook('second', 'DAY_NIGHT_CYCLE.onTick')

parse('sv_forcelight 1')
